<?php
/**
 * Module for payment provide by Payválida
 *
 * Pay/PayvPayment is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

namespace Payvalida\Bnpl\Controller\Pay;
use Magento\Framework\App\CsrfAwareActionInterface;
use Magento\Framework\App\RequestInterface;
use Magento\Framework\App\Request\InvalidRequestException;
use Magento\Sales\Model\Order;

class Index extends \Magento\Framework\App\Action\Action implements CsrfAwareActionInterface
{
    protected $resultPageFactory;
    protected $resultJsonFactory;
    protected $checkoutSession;
    protected $orderFactory;
    protected $cartManagement;
    protected $quote;
    protected $resultRedirect;
    protected $_curl;

    /**
     * Constructor
     *
     * @param \Magento\Framework\App\Action\Context  $context
     * @param \Magento\Framework\Json\Helper\Data $jsonHelper
   */  
    public function __construct(
        \Magento\Framework\App\Action\Context $context,
        \Magento\Framework\View\Result\PageFactory $resultPageFactory,
        \Magento\Framework\Controller\Result\JsonFactory $resultJsonFactory,
        \Magento\Checkout\Model\Session $checkoutSession,
        \Magento\Sales\Model\OrderFactory $orderFactory,
        \Magento\Quote\Api\CartManagementInterface $cartManagement,
        \Magento\Quote\Model\Quote $quote,
        \Magento\Framework\HTTP\Client\Curl $curl,
        \Magento\Framework\App\Helper\Context $contextApp,
        \Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
        \Payvalida\Bnpl\Controller\PaymentController $payment_controller,
        \Magento\Sales\Api\OrderRepositoryInterface $orderRepository,
        \Magento\Quote\Model\QuoteFactory $quoteFactory
    ) {
        $this->resultPageFactory = $resultPageFactory;
        $this->resultJsonFactory = $resultJsonFactory;
        $this->checkoutSession = $checkoutSession;
        $this->orderFactory = $orderFactory;
        $this->cartManagement = $cartManagement;
        $this->quote = $quote;
        $this->_curl = $curl;
        $this->contextApp = $contextApp;
        $this->scopeConfig = $scopeConfig;
        $this->paymentController = $payment_controller;
        $this->orderRepository = $orderRepository;
        $this->quoteFactory = $quoteFactory;
        parent::__construct($context);
    }

    public function createCsrfValidationException(RequestInterface $request): ? InvalidRequestException
    {
        return null;
    }

    public function validateForCsrf(RequestInterface $request): ?bool
    {
        return true;
    }

    /**
     * Execute view action
     *
     * @return \Magento\Framework\Controller\ResultInterface
    */     
    public function execute()
    {
        $result = $this->resultJsonFactory->create();
        $storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
        $pendingOrderState = "pending";
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $resource = $objectManager->get('Magento\Framework\App\ResourceConnection');
        $connection = $resource->getConnection();   
        if(isset($_GET['order'])){
            $orderId = $_GET['order'];
            $order = $objectManager->create('\Magento\Sales\Model\Order')->loadByAttribute('quote_id',$orderId);
            if (isset($order)) {
                $amount=$order->getData()['base_grand_total']; 
                $date=$order->getData()['created_at'];
                $status=$order->getData()['status'];
                $name=$order->getData()['customer_firstname']." ".$order->getData()['customer_lastname'];
                $email=$order->getData()['customer_email'];
            	?>
                <style>
                @import url('https://fonts.googleapis.com/css2?family=Montserrat:wght@400;500;600&display=swap');           
                #order_data {
                    padding: 20px 10px;
                    max-width: 900px;
                    margin: 20px auto;
                    border-radius: 10px;
                    background: #fff;
                    box-shadow: 2px 2px 6px hsla(0, 0%, 0%, .5);
                    font-family: 'Montserrat', sans-serif;
                }         
                #order_data * {
                    font-family: 'Montserrat', sans-serif;
                    color: #3a3a3a;
                }               
                #order_data h1 {
                    text-align: center;
                    text-transform: uppercase;
                    font-weight: bold;
                }        
                #order_data h2,
                #order_data p {
                    text-align: center;
                }       
                #order_data h3 {
                    text-transform: uppercase;
                    font-weight: bold;
                    margin: 0;
                }        
                #order_data table {
                    margin: 20px 0;
                    border-radius: 10px;
                    overflow: hidden;
                }  
                #order_data table,
                #order_data th,
                #order_data td {
                    border: 1px solid hsl(0deg 0% 0% / 20%);
                }            
                #order_data a {
                    text-transform: uppercase;
                    font-weight: bold;
                    display: inline-block;
                    padding: 10px 20px;
                    line-height: 1;
                    border-radius: 25px;
                    box-shadow: inset 0 0 0 1px hsl(0deg 0% 0% / 20%);
                    transition: .5s;
                }           
                #order_data a:hover {
                    box-shadow: inset 0 0 0 100px hsl(0deg 0% 0% / 20%);
                }           
                .panel-wrap.woocommerce {
                    padding: 0 10px;
                }           
                #order_data .content_table {
                    max-width: 100%;
                    overflow: auto;
                }           
                #order_data,
                #order_data * {
                    font-family: 'Montserrat', sans-serif;
                    color: #3a3a3a;
                    box-sizing: border-box;
                
                }        
                #order_data table {
                    width: 100%;
                }        
                #order_data td {
                    padding: 8px;
                    font-size: 13px;
                }        
                #order_data p {
                    margin: 0;
                    font-size: 13px;
                }        
                #order_data table {
                    border: 0;
                    box-shadow: 0 0 0 1px hsl(0deg 0% 0% / 20%);
                }        
                #order_data h1 {
                    font-size: 40px;
                    margin-bottom: 20px;
                    line-height: 1.2em;
                }        
                #order_data h2 {
                    font-size: 29px;
                    margin-bottom: 20px;
                    line-height: 1.2em;
                    font-weight: 300;
                    text-transform: none;
                }
                </style>
                <div class="panel-wrap woocommerce">
                    <div id="order_data" class="panel woocommerce-order-data">
                        <h1>
                            <?php echo __('Gracias por su compra');?>
                        </h1>
                        <h2>
                            <?php echo __('Detalles de Pedido')." #".$orderId;?>
                        </h2>
                        <p>
                            <?php echo __('Pago a través de Payvalida | PSE | Pagos en Efectivo.');?>
                        </p>
                        <div class="content_table">
                            <table>
                                <tr>
                                    <td colspan="2">
                                        <h3>
                                            <?php echo __('Generales');?>
                                        </h3>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <strong><?php echo __('Fecha de creación: ');?> </strong>
                                    </td>
                                    <td>
                                        <?php echo $date;?>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <strong><?php echo __('Estado: ');?> </strong>
                                    </td>
                                    <td>
                                        <?php echo $status;?>
                                    </td>
                                </tr>
                                <tr>
                                <tr>
                                    <td>
                                        <strong><?php echo __('Valor: ');?> </strong>
                                    </td>
                                    <td>
                                        <?php echo $amount;?>
                                    </td>
                                </tr>
                                <tr>    
                                    <td colspan="2">
                                        <h3>
                                            <?php echo __('DATOS DEL COMPRADOR');?>
                                        </h3>
                                    </td>
                                </tr>
                                <tr>
                                    <td>
                                        <strong><?php echo __('Nombre:');?> </strong>
                                    </td>
                                    <td>
                                        <?php echo $name;?>
                                    </td>
                                </tr>
                                
                                <tr>
                                    <td>
                                        <strong><?php echo __('Email:');?> </strong>
                                    </td>
                                    <td>
                                        <?php echo $email;?>
                                    </td>
                                </tr>
                                
                            </table>
                        </div>
                        <br>
                        <p>
                            <a href="/">
                                <?php echo __('VOLVER AL COMERCIO');?>
                            </a>
                        </p>
                    </div>
                </div>
                <?php
            }else{
            	echo '<h1><center>La petici&oacute;n es incorrecta! No se ha encontrado al orden.</center></h1>';
            }
            exit;
        }
       
        $data = json_decode(file_get_contents('php://input'), true);
        if(isset($data)){
	    	$_POST = $data;
    	}
    	
        if(isset($_POST)){
            if (empty($_POST['po_id'])||!preg_match("/^[a-zA-Z0-9' ]*$/",$_POST['po_id'])){
                echo '{
                    "status":"error"
                    "type":"Invalid po_id"
                }';
                exit;
            }
            $po_id = $_POST['po_id'];
            if (empty($_POST['status'])||!preg_match("/^[a-zA-Z-' ]*$/",$_POST['status'])){
                echo '{
                    "status":"error"
                    "type":"Invalid status"
                }';
                exit;
            }
            $status =$_POST['status'];
            if (empty($_POST['amount'])||!preg_match("/^[0-9.,' ]*$/",$_POST['amount'])){
                echo '{
                    "status":"error"
                    "type":"Invalid amount"
                }';
                exit;
            }
            $amount = $_POST['amount'];
            if (empty($_POST['pv_checksum'])){
                echo '{
                    "status":"error"
                    "type":"Invalid pv_checksum"
                }';
                exit;
            }
            $pv_checksum = $_POST['pv_checksum'];
            $FIXED_HASH_NOTIFICACION=$this->scopeConfig->getValue('payment/Bnpl/fixedHashNotification',$storeScope);
            $pv_checksum_c = hash('sha256', $po_id . $status . $FIXED_HASH_NOTIFICACION);
            if(!($pv_checksum_c == $pv_checksum)){
                echo '{
                    "status":"error"
                    "type":"pv_checksum invalid"
                }';
                exit; 
            }
	
            $order = $objectManager->create('\Magento\Sales\Model\Order')->loadByAttribute('quote_id',$po_id);
            switch ($status) {
                case "approved":
                    $order->setState(Order::STATE_PROCESSING, true);
                    $order->setStatus(Order::STATE_PROCESSING, true);
                    try{
                    $order->save();
                    } catch(\Exception $e){
                    echo $e;
                    return $result->setData(['Error No se creo la orden']);
                    }
                    echo '{
                        "status":"ok"
                        "type":"update_status processing"
                    }';
                    break;
                case "cancelled":
                    $order->setState(Order::STATE_CANCELED, true);
                    $order->setStatus(Order::STATE_CANCELED, true);
                    try{
                    $order->save();
                    } catch(\Exception $e){
                    echo $e;
                    return $result->setData(['Error No se creo la orden']);
                    }
                    echo '{
                        "status":"ok"
                        "type":"update_status cancelled"
                    }';
                    break;
            } 
	    } 
    }

    public function uploadInventory($orderId){
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $resource = $objectManager->get('Magento\Framework\App\ResourceConnection');
        $connection = $resource->getConnection();
        $order = $objectManager->create('\Magento\Sales\Model\Order')->loadByAttribute('quote_id',$orderId);
        $sql = "SELECT sku FROM quote_item WHERE quote_id = '$orderId'";
        $result = $connection->fetchAll($sql);
        if($result != null){
            foreach($result as $sku){
                $sku  = $sku["sku"];
                $sql_ = "SELECT MAX(reservation_id),sku,quantity FROM inventory_reservation WHERE sku = '$sku' ORDER BY reservation_id ASC";  
                $query = $connection->fetchAll($sql_);
                if($query != null){
                    foreach($query as $productInventory){
                        $queryUpload = $connection->update(
                            'inventory_reservation',
                            ['quantity' => '0.0000'],
                            ['reservation_id = ?' => $productInventory["MAX(reservation_id)"]]
                        );
                    }
                }
            }
        }
    }

    public function uploadStatusOrder($increment_id){
        $objectManager = \Magento\Framework\App\ObjectManager::getInstance();
        $resource = $objectManager->get('Magento\Framework\App\ResourceConnection');
        $connection = $resource->getConnection();
        $connection->update(
            'sales_order',
            ['state' => 'canceled'],
            ['increment_id = ?' => $increment_id]
        );
        $connection->update(
            'sales_order',
            ['status' => 'canceled'],
            ['increment_id = ?' => $increment_id]
        );
        $connection->update(
            'sales_order_grid',
            ['status' => 'canceled'],
            ['increment_id = ?' => $increment_id]
        );   
    }

    public function getRealOrderId()
    {
        $lastorderId = $this->checkoutSession->getLastOrderId();
        return $lastorderId;
    }

    public function getOrder()
    {
        if ($this->checkoutSession->getLastRealOrderId()) {
            $order = $this->orderFactory->create()->loadByIncrementId($this->checkoutSession->getLastRealOrderId());
            return $order;
        }
        return false;
    }

    public function getShippingInfo()
    {
        $order = $this->getOrder();
        if($order) {
            return $order->getShippingAddress();;
        }
        return false;
    }
}