<?php

	namespace Payvalida\Bnpl\Model;

	use Magento\Checkout\Model\ConfigProviderInterface;
	use Magento\ImportExport\Test\Unit\Model\Import\Entity\EavAbstractTest;
	use Payvalida\Bnpl\Controller\PaymentController;

	class CustomConfigProvider implements ConfigProviderInterface {
		/**
		 * {@inheritdoc}
		 */
		protected $_scopeConfig;
		public function __construct(
			\Magento\Framework\App\Helper\Context $context,
			\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
			PaymentController $Bnpl,
			\Magento\Store\Api\Data\StoreInterface $store
		)
		{
		    $this->_scopeConfig = $scopeConfig;
		    $this->Bnpl = $Bnpl;
		    $this->store = $store;

		}
		public function getConfig() {
			$storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
			$config = [
				'payment' => [
					'Bnpl' => [
						/**
						 * pay_title
						 * pay_description
						 * pay_merchant
						 * pay_key
						 * pay_public_key
						 * pay_callback
						 * pay_confirmation
						 * pay_test
						 * vertical_cs
						 *
						 */
						'payco_title'=> $this->_scopeConfig->getValue('payment/Bnpl/pay_title',$storeScope),
						'merchantId'=> $this->_scopeConfig->getValue('payment/Bnpl/merchantId',$storeScope),
                        'fixedHash'=> $this->_scopeConfig->getValue('payment/Bnpl/fixedHash',$storeScope),
                        'fixedHashNotification'=> $this->_scopeConfig->getValue('payment/Bnpl/fixedHashNotification',$storeScope),
						'payco_merchant'=> $this->_scopeConfig->getValue('payment/Bnpl/pay_merchant',$storeScope),
						'payco_key'=> $this->_scopeConfig->getValue('payment/Bnpl/pay_key',$storeScope),
						'payco_public_key'=> $this->_scopeConfig->getValue('payment/Bnpl/pay_public_key',$storeScope),
						'payco_callback'=> $this->_scopeConfig->getValue('payment/Bnpl/pay_callback',$storeScope),
						'payco_test'=> $this->_scopeConfig->getValue('payment/Bnpl/pay_test',$storeScope),
						'vertical_cs'=> $this->_scopeConfig->getValue('payment/Bnpl/vertical_cs',$storeScope),
						'responseAction'=>$this->Bnpl->responseAction(),
						'getOrderId'=>$this->Bnpl->getOrderId(),
                        'getQuoteData'=>$this->Bnpl->getQuoteData(),
                        'getStoreData'=>$this->Bnpl->getStoreData(),
                        'getOrderIncrementId'=>$this->Bnpl->getOrderIncrementId(),
                        'getQuoteIncrementId'=>$this->Bnpl->getQuoteIncrementId(),
                        'getQuoteIdData'=>$this->Bnpl->getQuoteIdData(),
						'language'=>$this->getLanguage()
					]
				]
			];
			return $config;
		}
		public function getLanguage(){
			$objectManager = \Magento\Framework\App\ObjectManager::getInstance();
			$store = $objectManager->get('Magento\Framework\Locale\Resolver');

			return $store->getLocale();
		}
	}