<?php

	namespace Payvalida\Payv\Model;

	use Magento\Checkout\Model\ConfigProviderInterface;
	use Magento\ImportExport\Test\Unit\Model\Import\Entity\EavAbstractTest;
	use Payvalida\Payv\Controller\PaymentController;

	class CustomConfigProvider implements ConfigProviderInterface {
		/**
		 * {@inheritdoc}
		 */
		protected $_scopeConfig;
		public function __construct(
			\Magento\Framework\App\Helper\Context $context,
			\Magento\Framework\App\Config\ScopeConfigInterface $scopeConfig,
			PaymentController $payv,
			\Magento\Store\Api\Data\StoreInterface $store
		)
		{
		    $this->_scopeConfig = $scopeConfig;
		    $this->payv = $payv;
		    $this->store = $store;

		}
		public function getConfig() {
			$storeScope = \Magento\Store\Model\ScopeInterface::SCOPE_STORE;
			$config = [
				'payment' => [
					'payv' => [
						/**
						 * pay_title
						 * pay_description
						 * pay_merchant
						 * pay_key
						 * pay_public_key
						 * pay_callback
						 * pay_confirmation
						 * pay_test
						 * vertical_cs
						 *
						 */
						'payco_title'=> $this->_scopeConfig->getValue('payment/payv/pay_title',$storeScope),
						'expirationDays'=> $this->_scopeConfig->getValue('payment/payv/expirationDays',$storeScope),
						'merchantId'=> $this->_scopeConfig->getValue('payment/payv/merchantId',$storeScope),
                        'fixedHash'=> $this->_scopeConfig->getValue('payment/payv/fixedHash',$storeScope),
                        'fixedHashNotification'=> $this->_scopeConfig->getValue('payment/payv/fixedHashNotification',$storeScope),
						'payco_merchant'=> $this->_scopeConfig->getValue('payment/payv/pay_merchant',$storeScope),
						'payco_key'=> $this->_scopeConfig->getValue('payment/payv/pay_key',$storeScope),
						'payco_public_key'=> $this->_scopeConfig->getValue('payment/payv/pay_public_key',$storeScope),
						'payco_callback'=> $this->_scopeConfig->getValue('payment/payv/pay_callback',$storeScope),
						'payco_test'=> $this->_scopeConfig->getValue('payment/payv/pay_test',$storeScope),
						'vertical_cs'=> $this->_scopeConfig->getValue('payment/payv/vertical_cs',$storeScope),
						'responseAction'=>$this->payv->responseAction(),
						'getOrderId'=>$this->payv->getOrderId(),
                        'getQuoteData'=>$this->payv->getQuoteData(),
                        'getStoreData'=>$this->payv->getStoreData(),
                        'getOrderIncrementId'=>$this->payv->getOrderIncrementId(),
                        'getQuoteIncrementId'=>$this->payv->getQuoteIncrementId(),
                        'getQuoteIdData'=>$this->payv->getQuoteIdData(),
						'language'=>$this->getLanguage()
					]
				]
			];
			return $config;
		}
		public function getLanguage(){
			$objectManager = \Magento\Framework\App\ObjectManager::getInstance();
			$store = $objectManager->get('Magento\Framework\Locale\Resolver');

			return $store->getLocale();
		}
	}