/**
 * Copyright 漏 2015 Magento. All rights reserved.
 */
/*browser:true*/
/*global define*/
 
define(
    [
        "jquery",
        'Magento_Checkout/js/view/payment/default',
        'mage/url',
        'Magento_Checkout/js/model/quote',
        'Magento_Checkout/js/checkout-data',
        'Magento_Checkout/js/model/authentication-messages',
        'Magento_Checkout/js/model/url-builder',
        'Magento_Customer/js/model/customer',
        'Magento_Checkout/js/model/place-order',
        'https://docs.payvalidda.net/checkout8.js'
    ],
    function ($,Component,url,quote,checkoutData,messageContainer, urlBuilder, customer, placeOrderService) {
        'use strict';
        return Component.extend({
            defaults: {
                self:this,
                template: 'Payvalida_Payv/payment/payv'
            },
            redirectAfterPlaceOrder: false,
            renderCheckout: async function() {
                var button0 = document.getElementsByClassName('action primary checkout')[0];
                var button1 = document.getElementsByClassName('action primary checkout')[1];
                button0.disabled = true;
                button1.disabled = true;
                button0.style.disabled = true;
                button1.style.disabled = true;
                var countryBllg = quote.shippingAddress();
                var customerData = checkoutData.getShippingAddressFromData();
                var paymentData = {
                    method: 'payv'
                };
                var serviceUrl, payload;
                payload = {
                    cartId: quote.getQuoteId(),
                    billingAddress: quote.billingAddress(),
                    paymentMethod: paymentData
                };

                if (customer.isLoggedIn()) {
                    serviceUrl = urlBuilder.createUrl('/carts/mine/payment-information', {});
                } else {
                    serviceUrl = urlBuilder.createUrl('/guest-carts/:quoteId/payment-information', {
                        quoteId: quote.getQuoteId()
                    });
                    payload.email = quote.guestEmail;
                }
                placeOrderService(serviceUrl, payload, messageContainer);
                var orderId = this.getOrderId();
                var getQuoteIncrement = this.getQuoteIncrementId();
                var totals = quote.getTotals();
                var quoteIdData = this.getQuoteIdData();
                var invoice;
                var settings = {
                    "url": url.build("response/payment/index"),
                    "method": "POST",
                    "timeout": 120,
                    "async":false,
                    "headers": {
                        "X-Requested-With": "XMLHttpRequest",
                        "Content-Type": "application/x-www-form-urlencoded",
                    },
                    "data": {
                        "order_id": quoteIdData
                    }
                }
                 await $.ajax({
                    url: url.build("response/payment/index"),
                    headers: {
                        'X-Requested-With': 'XMLHttpRequest',
                        'Content-Type': 'application/x-www-form-urlencoded'
                    },
                    method: 'POST',
                    async: false,
                    data:  {
                        "order_id": quoteIdData
                    },
                    success: function(data){
                        console.log('processing...');
                        if(data == "warning" || data.length == 0 || data == "error" ) {
                            $.ajax(settings).done(function (response) {
                                if( response.increment_id){
                                    invoice = response.increment_id;
                                }
                            });
                        }else{
                            invoice = data.increment_id;
                        }
                        if(invoice){
                            var method = "";
                            if(window.checkoutConfig.payment.payv.payco_test == "1"){
                               var urlApi="https://api-test.payvalida.com/api/v3/wporders";
                               window.checkoutConfig.payment.payv.payco_test= "true";
                               var test2 = true;
                            }else{
                               var urlApi="https://api.payvalida.com/api/v3/wporders";
                               window.checkoutConfig.payment.payv.payco_test = "false";
                               var test2 = false;
                            }
                            var fixedH= window.checkoutConfig.payment.payv.fixedHash;
                            var merchant= window.checkoutConfig.payment.payv.merchantId;
                            var expirationDays = 1;
                            if (parseInt(window.checkoutConfig.payment.payv.expirationDays)>1 && parseInt(window.checkoutConfig.payment.payv.expirationDays)<=30){
                                expirationDays = parseInt(window.checkoutConfig.payment.payv.expirationDays);
                            }
                            var items = '';
                            for(var i = 0; i <  window.checkoutConfig.quoteItemData.length; i++){
                               if(window.checkoutConfig.totalsData.items.length==1){
                                   items=window.checkoutConfig.quoteItemData[i].product.name;
                               }else{
                                   items += window.checkoutConfig.quoteItemData[i].product.name+',';
                               }

                            }
                            var myHeaders = new Headers();
                            myHeaders.append("Content-Type", "application/json");
                            var docType, mobile, doc, country, name_billing, address_billing, address_billing1, address_billing2, city_billing, state_billing, firstname_billing, lastname_billing, lang_list, lang, amount, taxes, tax_base;
                            var additional_information = makeAdditionalInformation();
                            redirectToCheckout();
                            
                            //TODO: Add unit test (https://dev.azure.com/payvalida/payValida/_workitems/edit/27832)
                            function makeAdditionalInformation(){
                                if(!window.checkoutConfig.isCustomerLoggedIn){
                                    if(customerData){
                                        name_billing =  customerData.firstname + ' ' + customerData.lastname;
                                        address_billing =  customerData.street[0]+ ' ' + customerData.street[1];
                                        address_billing1 =customerData.street[0];
                                        address_billing2 =customerData.street[1];
                                        country = customerData.country_id;
                                        city_billing =customerData.city;
                                        state_billing =customerData.state;
                                        firstname_billing = customerData.firstname;
                                        lastname_billing = customerData.lastname;
                                        mobile = customerData.telephone;
                                    }else{
                                        country = 'CO';
                                    }
                                }else{
                                    name_billing = window.checkoutConfig.customerData.firstname + ' '+ window.checkoutConfig.customerData.lastname;
                                    mobile = countryBllg.telephone;
                                    address_billing1 = countryBllg.street[0];
                                    country = countryBllg.countryId;
                                }
                                lang_list = window.checkoutConfig.payment.Bnpl.language.split("_");
                                lang = lang_list[0];
                                amount = totals._latestValue.base_grand_total;
                                taxes = totals._latestValue.base_tax_amount;
                                tax_base = amount - taxes;
                                return additional_information = {
                                    "client": {
                                        "address": {
                                            "country": country,
                            				"line1": address_billing1,
                            				"line2": address_billing2,
                            				"city": city_billing,
                            				"state": state_billing
                                        },
                                        "personal_information": {
                                            "firstname": firstname_billing,
                            				"lastname": lastname_billing,
                            				"contact_information": {
                            				    "phone": mobile,
                            				    "email": quote.guestEmail
                            				}
                                        }
                                    }
                                }
                            }
                
                            function sha512(str){
                                return crypto.subtle.digest("SHA-512", new TextEncoder("utf-8").encode(str)).then(buf => {
                                    return Array.prototype.map.call(new Uint8Array(buf), x=>(('00'+x.toString(16)).slice(-2))).join('');
                                });
                            }
                            
                            function redirectToCheckout(){
                                try{
                                sha512(quote.guestEmail+orderId+amount.toString()+fixedH).then(x => {
                                    redirect1(x).then(response => {
                                    if (response.CODE !== "0000"){
                                        alert(response.DESC);
                                    }
                                     let txt=response.DATA.checkout;
                                     console.log(txt);
                                     window.location.href ="https://"+txt;
                                    }).catch(error => console.log("Error redirect1. ",error));
                                });
                                } catch(error){
                                    alert(error)
                                    console.log("Error catch: ",error)
                                }
                            }
 
                            function redirect1(x) {
                                return new Promise((resolve,reject) => {
                                    var raw = JSON.stringify({
                                        "merchant":merchant,
                                        "email":quote.guestEmail,
                                        "country":343,
                                        "order":orderId,
                                        "money":"COP",
                                        "amount":amount.toString(),
                                        "description":items,
                                        "method":"",
                                        "language":"es",
                                        "plugin":"Magento",
                                        "expirationdays":expirationDays,
                                        "recurrent":true,
                                        "iva":"0",
                                        "checksum": x,
                                        "user_di":doc,
                                        "user_type_di":docType,
                                        "user_name":name_billing,
                                        "additional_information":additional_information,
                                        "shortener":false,
                                        "redirect_timeout":"300000"});
                                    var requestOptions = {
                                      method: 'POST',
                                      headers: myHeaders,
                                      body: raw,
                                      redirect: 'follow'
                                    };
                                    fetch(urlApi, requestOptions)
                                    .then(response => response.text())
                                    .then(result => {
                                        console.log(result);
                                        resolve(JSON.parse(result));
                                    })
                                     .catch(error => console.log('error', error));
                                })
                            }
                            button0.disabled = false;
                            button1.disabled = false;
                            button0.style.disabled = false;
                            button1.style.disabled = false;
                       }
                    },
                    error :function(error){
                        console.log('error: '+error);
                    }
                });

            },
            getOrderId: function(){
                return window.checkoutConfig.payment.payv.getOrderId;
            },
            getQuoteData: function(){
                return window.checkoutConfig.payment.payv.getQuoteData;
            },
            getStoreData: function(){
                return window.checkoutConfig.payment.payv.getStoreData;
            },
            getOrderIncrementId: function(){
                return window.checkoutConfig.payment.payv.getOrderIncrementId;
            },
            getQuoteIncrementId: function(){
                return window.checkoutConfig.payment.payv.getQuoteIncrementId;
            },
            getQuoteIdData: function(){
                return window.checkoutConfig.payment.payv.getQuoteIdData;
            },
            getdisplayTitle: function () {
                return window.checkoutConfig.payment.payv.payco_title;
            },
            text: function(){
                return window.checkoutConfig.payment.payv.text;
            },
            getMailingAddress: function() {
                return window.checkoutConfig.payment.checkmo.mailingAddress;
            },
            responseAction: function(){
                return window.checkoutConfig.payment.payv.responseAction;
            },
        });
    }
);